package com.csc.library.command;

import java.util.Iterator;

import com.csc.library.command.util.CommonParameterUtil;
import com.csc.library.request.CommonModeParameter;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.MyLog;

/* save record */
public class Command002 extends CommandRecord<CommonModeParameter>{

	@Override
	public void execute(CommonModeParameter param) throws Exception {
		try{
			DbRecord rec = new InitialRecord(this.getUProfile()).getDbRecord(param.getTableName());
			
			CommonParameterUtil.setKeyRecord(rec, param);
			CommonParameterUtil.setJsonData(rec, param);
			
			int saveStatus = rec.save();
			this.sendMessage("SaveRecord status : "+saveStatus);
			this.setRecord(rec);
		}catch(Exception e){
			MyLog.error(this ,this.getUProfile(), e);
			this.sendMessage(e.getMessage());
		}
	}
	
}
