package com.csc.library.command;

import com.csc.library.factory.ResponseFactory;
import com.csc.library.properties.CommandState;
import com.csc.library.properties.CscSession;
import com.csc.library.request.CMDMode;
import com.csc.library.request.RequestWebsocket;
import com.csc.library.response.ResponseStatus;
import com.csc.library.utilities.UProfile;

public abstract class CommandBase<T> implements CscCommand<T>{
	protected CMDMode commandMode = null;
	private CscSession session = null;
	private RequestWebsocket request = null;
	protected CommandState statusCode = CommandState.Created;
	
	public final void setSession(CscSession session){
		this.session = session;
	}
	
	public final CscSession getSession(){
		return this.session;
	}
	
	public final void setRequest(RequestWebsocket req){
		this.request = req;
	}
	
	public final RequestWebsocket getRequest(){
		return this.request;
	}
	
	public UProfile getUProfile(){
		return this.session.getUProfile();
	}

	public CommandState getStatusCode(){
		return this.statusCode;
	}
	
	public final void sendMessage(String message){
		ResponseFactory.getInstance().sendResponseWebsocket(
				this.getSession(), 
				this.getRequest(), 
				ResponseStatus.SendMessage, 
				message);
	}
}
