package com.csc.library.command;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import com.csc.library.response.ResponseData;
import com.csc.library.session.DbRecord;
import com.csc.library.utilities.MyLog;

public abstract class CommandLists<T> extends CommandBase<T>{
	private List<Map<String,String>> result = new ArrayList<Map<String,String>>();

	@Override
	public final void setResult(ResponseData res) {
		res.setData(this.result);
	}
	
	protected final void putNewRecord(DbRecord rec){
		try{
			Map<String,String> map = new HashMap<String,String>();
			Vector v = rec.getArrayFieldList();
			for(int i = 0; i < v.size(); i++){
				String field = (String) v.get(i);
				map.put(field, rec.getString(field));
			}
			result.add(map);
		}catch(Exception e){
			MyLog.error(this , this.getUProfile() , e);
		}
	}
	
	protected final void putNewRecord(Map<String,String> map){
		result.add(map);
	}
}
