package com.csc.library.command;

import java.util.HashMap;
import java.util.Map;
import java.util.Vector;

import com.csc.library.response.ResponseData;
import com.csc.library.session.DbRecord;
import com.csc.library.utilities.MyLog;

public abstract class CommandRecord<T> extends CommandBase<T>{
	private Map<String,String> result = new HashMap<String,String>();
	
	@Override
	public final void setResult(ResponseData res) {
		res.setData(this.result);
	}
	
	protected final void setString(String fieldName , String data){
		result.put(fieldName, data);
	}
	
	protected final void setRecord(DbRecord rec){
		try{
			Vector v = rec.getArrayFieldList();
			for(int i = 0; i < v.size(); i++){
				String field = (String) v.get(i);
				this.setString(field, rec.getString(field));
			}
		}catch(Exception e){
			MyLog.error(this , this.getUProfile() , e);
		}
	}
}
