package com.csc.library.controller;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.csc.library.command.CscCommand;
import com.csc.library.request.CMDMode;
import com.csc.library.request.RequestParameter;
import com.csc.library.request.RequestWebsocket;

public class CMDModeCtrlCommand {
	private static CMDModeCtrlCommand instance;
	private List<CMDModeCtrl> list = new ArrayList<CMDModeCtrl>();
	//private Map<CMDMode , CMDModeCtrl> mode = new HashMap<CMDMode ,CMDModeCtrl>();
	
	private CMDModeCtrlCommand() throws Exception{
		
		list.set(CMDMode.common.getModeCode(), new CommonCtrl());
		list.set(CMDMode.special.getModeCode(), new SpecialCtrl());
		list.set(CMDMode.process.getModeCode(), new ProcessCtrl());
		
		/*mode.put(CMDMode.common , new CommonCtrl());
		mode.put(CMDMode.special , new SpecialCtrl());
		mode.put(CMDMode.process , new ProcessCtrl());*/
		
		if(CMDMode.values().length != list.size()){
			throw new Exception("!!! CMDModeCtrlCommand :: Error CMDMode not match Controller !!!");
		}
	}
	
	public static CMDModeCtrlCommand getInstance() throws Exception{
		if(instance == null){
			instance = new CMDModeCtrlCommand();
		}
		return instance;
	}
	
	public void execute(CscCommand command , RequestWebsocket req) throws Exception {
		//mode.get(req.getCommandMode()).execute(command, req.getRequestParameter());
		list.get(req.getCommandMode().getModeCode()).execute(command, req.getRequestParameter());
	}
	
	
	interface CMDModeCtrl{
		public void execute(CscCommand command ,RequestParameter reqParam) throws Exception ;
	}
	
	class CommonCtrl implements CMDModeCtrl{
		@Override
		public void execute(CscCommand command , RequestParameter reqParam) throws Exception {
			command.execute(reqParam.getCommonParameter());
		}
	}
	
	class SpecialCtrl implements CMDModeCtrl{
		@Override
		public void execute(CscCommand command , RequestParameter reqParam) throws Exception {
			command.execute(reqParam.getSpecialParameter());
		}
	}
	
	class ProcessCtrl implements CMDModeCtrl{
		@Override
		public void execute(CscCommand command , RequestParameter reqParam) throws Exception {
			command.execute(reqParam.getProcessParameter());
		}
	}
	
}
