package com.csc.library.factory;

import java.util.ArrayList;
import java.util.List;

import com.csc.library.command.CommandBase;
import com.csc.library.command.CscCommand;
import com.csc.library.properties.CscSession;
import com.csc.library.request.CMDMode;
import com.csc.library.request.RequestWebsocket;

public class CommandFactory {
	private static CommandFactory instance;
	private List<CscCommand> listCommand = new ArrayList<CscCommand>();
	private CMDMode mode = CMDMode.common;
	
	private CommandFactory(){
		/*load command*/
	}
	
	public static CommandFactory getInstance(){
		if(instance == null){
			instance = new CommandFactory();
		}
		return instance;
	}
	
	public CscCommand getCommand(CscSession session ,RequestWebsocket req){
		CommandBase command = null;
		if(mode.common == req.getCommandMode()){
			try{
				Class c = Class.forName("com.csc.library.command."+req.getCommandCode());
				command = (CommandBase)c.newInstance();
				command.setRequest(req);
				command.setSession(session);
			}catch(Exception e){
				e.printStackTrace();
			}
		}
		return command;
	}
}
