package com.csc.library.factory;

import com.csc.library.gson.SerializeAndDeserializeBase;
import com.csc.library.request.CommonModeParameter;
import com.csc.library.request.CommonParameterImpl;
import com.csc.library.request.ReqParameterImpl;
import com.csc.library.request.RequestParameter;
import com.csc.library.request.RequestPropertiesImpl;
import com.csc.library.request.RequestWebsocket;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

public class RequestFactory {
	private static RequestFactory instance;
	private Gson gson = null;
	
	private RequestFactory() {
		GsonBuilder gb = new GsonBuilder();
		gb.registerTypeAdapter(RequestWebsocket.class, new SerializeAndDeserializeBase(RequestPropertiesImpl.class));
		gb.registerTypeAdapter(RequestParameter.class, new SerializeAndDeserializeBase(ReqParameterImpl.class));
		gb.registerTypeAdapter(CommonModeParameter.class, new SerializeAndDeserializeBase(CommonParameterImpl.class));
		gson = gb.serializeNulls().create();
	}
	
	public static RequestFactory getInstance(){
		if(instance==null){
			instance = new RequestFactory();
		}
		return instance;
	}
	
	public RequestWebsocket createRequestWebSocket(String json){
		return gson.fromJson(json, RequestPropertiesImpl.class);
	}
}
